## Created by Rachael K. Hinkle
## Please cite Nelson & Hinkle, Crafting the Law, Justice System Journal (2018)
## Code to read in separate .txt files with one Shepard's report each and
##    create one .csv fiile with one row per citation

## Created using Python Version 2.7.3

import re, csv, os, string, operator


mydir = "/Users/username/citationProject/"

fout = open(mydir + "citelist.csv", "w")

outfilehandle = csv.writer(fout,
                           delimiter=",",
                           quotechar='"',
                           quoting=csv.QUOTE_NONNUMERIC)

localrow = []
localrow.append("Filename")
localrow.append("CiteNumber") 
localrow.append("CitingCase") 
localrow.append("CitingReporter") 
localrow.append("CitingCourt")      
localrow.append("CitingCaseYear") 
localrow.append("NotCitingCase")
localrow.append("RawText")
localrow.append("Treatment") 
localrow.append("PositiveTreatment")
localrow.append("NegativeTreatment")
localrow.append("treat1")
localrow.append("treat2")
localrow.append("treat3")
localrow.append("treat4")
localrow.append("treat5")
localrow.append("conTreat1")
localrow.append("conTreat2")
localrow.append("conTreat3")
localrow.append("disTreat1")
localrow.append("disTreat2")
localrow.append("disTreat3")


outfilehandle.writerow(localrow)

# Set location of folder where individual Shepards Reports are located (in .txt files)
indirname = mydir + "ShepardsReports/"
indirlist = os.listdir(indirname)

print len(indirlist)

cleandirlist = []
for entry in indirlist:
    matchresult = re.match('.+\\.txt$', entry)
    if matchresult != None:
        cleandirlist.append(matchresult.group())

for entry in cleandirlist:
    infilepath = indirname + entry
    infilehandle = open(infilepath)
    txtlines = infilehandle.readlines()
    print entry

    
    i=0

    num_lines = sum(1 for line in open(infilepath))
    court_section = ""
    live_line = False
        
    for txtlines[i] in txtlines:
        case_outciteID = ""
        cite_number = 0
        not_case = 0
        treatment = ""
        treat_hol = []
        maj_treat_hol = []
        con_treat_hol = []
        dis_treat_hol = []
        mtreat1 = ""
        mtreat2 = ""
        mtreat3 = ""
        mtreat4 = ""
        mtreat5 = ""
        ctreat1 = ""
        ctreat2 = ""
        ctreat3 = ""
        dtreat1 = ""
        dtreat2 = ""
        dtreat3 = ""
        citing_case_name = ""
        citing_case = ""
        signal = ""
        citing_court = ""
        citing_case_year = ""
        paren = ""
        chunk1 = ""
        chunk3 = ""
        raw_text = ""
        split = ""
        split2 = ""
        split3 = ""
        split4 = ""
        split_trt = ""
        pos_treat = 0
        neg_treat = 0

        if re.search("^SHEPARD\'S SUMMARY", txtlines[i]):
            live_line = True

        if re.search("^([A-Z0-9]+|[A-Z\.\']+) ", txtlines[i]) and not re.search("^[0-9]{4} ", txtlines[i]):
            court_section = txtlines[i]
            court_section = re.sub("\([A-Za-z0-9\s]+\)", "", court_section)
            court_section = court_section.strip()
            court_section = re.sub("", "", court_section)

        #Finding the line containing CITE NUMBER and TREATMENT
        if live_line and (re.search("^\d+\. ",txtlines[i].strip()) or re.search("^[\d]{4} ", txtlines[i])):
            block = "" 
            match = re.search("\d+\.",txtlines[i])
            
            #create a single line for each citation entry to help with parsing          
            j=i
            while j<num_lines and re.search("First Ref",txtlines[j])==None and txtlines[j].strip() != "":
                block = block + " " + (txtlines[j]).strip()
                j=j+1

            block = re.sub(" \. ", " ", block)
            block = re.sub("[\s]+", " ", block)
            block = string.strip(block)
            raw_text = block
            block = re.sub("\$[\s]?[0-9,.]+", ",", block)
            block = re.sub("\(,\)", ",", block)
            block = re.sub("\([A-Za-z.]+\)", "", block)
            
            block = re.sub("\([0-9]{1,2}\)", "", block)
            block = re.sub("\([^0-9]*\)", "", block)
            block = re.sub(", etc\., ", ", ", block)
            block = re.sub(", [0-9]+," , "", block)
            block = re.sub("\(6th Cir\.\)" , "", block)
            block = re.sub("\((1st|2d|3d|4th)\)" , "", block)
            block = re.sub("\(\)" , "", block)
            block = re.sub("\(\)" , "", block)
            block = re.sub("\(\)" , "", block)
            
            #split each block into an array seperated by " "
            split = re.split(" ", block)
            j=0

            cite_number = split[0]
            cite_number = re.sub("\.", "", cite_number)
                    
            #clean the line to grab full treatment
            split_trt = re.split(":", block)

            if len(split_trt) > 1:
                treatment = split_trt[0]

            if not re.search("[a-z]", treatment):
                treatment = ""
           
            treatment = re.sub("[0-9]+\.?","",treatment)
            treatment = treatment.strip()
            treatment = re.sub(", en banc,", " en banc", treatment)

            #process treatment
            treat_hol = re.split(", ", treatment)

            for treat in treat_hol:
                if re.search("Concurring", treat):
                    con_treat_hol.append(treat)

                if re.search("Dissenting", treat):
                    dis_treat_hol.append(treat)

                if not re.search("Concurring", treat) and not re.search("Dissenting", treat):
                    maj_treat_hol.append(treat)
                    
                    if re.search("Followed", treat):
                        pos_treat = 1

                    if re.search("Criticized|Distinguished|Limited|Questioned|Overruled|Superced", treat):
                        neg_treat = 1

            if len(maj_treat_hol) > 4:
                mtreat5 = maj_treat_hol[4]
            if len(maj_treat_hol) > 3:
                mtreat4 = maj_treat_hol[3]
            if len(maj_treat_hol) > 2:
                mtreat3 = maj_treat_hol[2]
            if len(maj_treat_hol) > 1:
                mtreat2 = maj_treat_hol[1]
            if len(maj_treat_hol) > 0:
                mtreat1 = maj_treat_hol[0]

            if len(con_treat_hol) > 2:
                ctreat3 = con_treat_hol[2]
            if len(con_treat_hol) > 1:
                ctreat2 = con_treat_hol[1]
            if len(con_treat_hol) > 0:
                ctreat1 = con_treat_hol[0]

            if len(dis_treat_hol) > 2:
                dtreat3 = dis_treat_hol[2]
            if len(dis_treat_hol) > 1:
                dtreat2 = dis_treat_hol[1]
            if len(dis_treat_hol) > 0:
                dtreat1 = dis_treat_hol[0]

            
            #bypass some misidentifications from the beginning of the text
            if i>20:
                split2 = re.split("[\()]", block)

                chunk1 = split2[0]
                chunk1 = chunk1.strip()

                if len(split2) > 2:
                    paren = split2[1]
                    paren = paren.strip()

                    if re.search("\d{4}$", paren):
                        citing_case_year = re.search("\d{4}$", paren).group(0)

                    citing_court = re.sub("[\s]*\d{4}$", "", paren)
                    citing_court = re.sub("-", "", citing_court)
                    signal = split2[2]
                    signal = signal.strip()

                        
                    if len(re.split(",[\s]+(\d)", chunk1)) > 2:
                        citing_case = re.split(",[\s]+(\d)", chunk1)[1]+re.split(",[\s]*(\d)", chunk1)[2]
                    
                    if citing_case == "" :
                        if len(re.split(",[\s]+(La\.)", chunk1)) > 2:
                            citing_case = re.split(",[\s]+(La\.)", chunk1)[1]+re.split(",[\s]*(La\.)", chunk1)[2]

                    signal = re.sub("Signal: ", "", signal)

            
            if citing_court == "":
                citing_court = re.sub("\d", "", citing_case)
                citing_court = citing_court.strip()
                

            if citing_case == "":
                if len(split_trt) > 1:
                    split4 = re.split(",", split_trt[1])
                    citing_case = split4[0].strip()
                

            if not re.search("(COURT|DECISION)", court_section):
                not_case = 1

        
            localrow = []
            localrow.append(entry)
            localrow.append(cite_number)
            
            localrow.append(citing_case)
            localrow.append(citing_court)
            localrow.append(court_section)
            localrow.append(citing_case_year)
            localrow.append(not_case)
            localrow.append(raw_text)

            localrow.append(treatment)
            localrow.append(pos_treat)
            localrow.append(neg_treat)
            localrow.append(mtreat1)
            localrow.append(mtreat2)
            localrow.append(mtreat3)
            localrow.append(mtreat4)
            localrow.append(mtreat5)
            localrow.append(ctreat1)
            localrow.append(ctreat2)
            localrow.append(ctreat3)
            localrow.append(dtreat1)
            localrow.append(dtreat2)
            localrow.append(dtreat3)
            
            outfilehandle.writerow(localrow)


        i=i+1


infilehandle.close()
fout.close()
